<%-- $Id: edit_default_membership.jsp 7604 2019-02-25 12:19:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.NameableConverter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="java.util.Date"
	import="org.json.simple.JSONArray"
	import="org.json.simple.JSONObject"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.USER;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Default group and role membership";

	// Query to retrieve default groups
	ItemQuery<Group> groupQuery = Group.getQuery();
	groupQuery.include(Include.ALL);
	groupQuery.restrict(
		Restrictions.eq(
			Hql.property("default"), 
			Expressions.parameter("isDefault", true, Type.BOOLEAN)
		)
	);
	groupQuery.order(Orders.asc(Hql.property("name")));
	JSONObject jsonGroups = new JSONObject();
	jsonGroups.put("itemType", "GROUP");
	jsonGroups.put("name", "Groups");
	jsonGroups.put("items", JsonUtil.toArray(groupQuery.iterate(dc), new NameableConverter<Group>()));

	// Query to retrieve default roles
	ItemQuery<Role> roleQuery = Role.getQuery();
	roleQuery.include(Include.ALL);
	roleQuery.restrict(
		Restrictions.eq(
			Hql.property("default"), 
			Expressions.parameter("isDefault", true, Type.BOOLEAN)
		)
	);
	roleQuery.order(Orders.asc(Hql.property("name")));
	JSONObject jsonRoles = new JSONObject();
	jsonRoles.put("itemType", "ROLE");
	jsonRoles.put("name", "Roles");
	jsonRoles.put("items", JsonUtil.toArray(roleQuery.iterate(dc), new NameableConverter<Role>()));

	JSONArray jsonMembers = new JSONArray();
	jsonMembers.add(jsonGroups);
	jsonMembers.add(jsonRoles);
	
	final boolean readGroups = sc.hasPermission(Permission.READ, Item.GROUP);
	final boolean useGroups = sc.hasPermission(Permission.USE, Item.GROUP);
	final boolean writeGroups = sc.hasPermission(Permission.WRITE, Item.GROUP);
	final boolean writeRoles = sc.hasPermission(Permission.WRITE, Item.ROLE);
	final boolean writeMembership = writeGroups && writeRoles;
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="linkitems-2.js,~default_membership.js" />
	<base:body>
		<h1><%=title%> <base:help helpid="user.edit.default_membership" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-everyone-id="<%=SystemItems.getId(Group.EVERYONE) %>"
			></div>
		
		<form action="index.jsp?ID=<%=ID%>" method="post" name="user">
		<input type="hidden" name="cmd" value="UpdateDefaultMembership">

		<div class="content">
			<table class="fullform input100 smaller bottomborder">
			<tr class="dynamic">
			<th>Member in</th>
			<td>
				<div class="selectionlist">
					<table>
					<tr>
						<td>
							<select name="membership" id="membership"
								class="auto-init"
								data-auto-init="link-container"
								data-initial-items="<%=HTML.encodeTags(jsonMembers.toJSONString()) %>"
								size="16" multiple <%=!writeMembership ? "disabled readonly class=\"disabled\"" : ""%>>
							</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnAddGroups"
									subclass="leftaligned auto-init"
									data-auto-init="add-link"
									data-list-id="membership"
									data-item-type="GROUP"
									data-exclude="<%=SystemItems.getId(Group.EVERYONE) %>"
									style="width: 12em;"
									title="Add&nbsp;groups&hellip;"  
									tooltip="Add groups to this user"
									disabled="<%=!writeMembership %>" 
								/>
								<base:button 
									id="btnAddRoles"
									subclass="leftaligned auto-init"
									data-auto-init="add-link"
									data-list-id="membership"
									data-item-type="ROLE"
									style="width: 12em;"
									title="Add&nbsp;roles&hellip;"  
									tooltip="Add roles to this user"
									disabled="<%=!writeMembership %>" 
								/>
								<base:button 
									id="btnRemoveMembership"
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="membership"
									data-item-type="GROUP"
									style="width: 12em;"
									title="Remove" 
									tooltip="Remove the user from the selected items"
									disabled="<%=!writeMembership%>" 
								/>
							</base:buttongroup>
							<div class="messagecontainer note">
								The selected roles and groups will automatically be assigned to new users.
							</div>
						</td>
					</tr>
					</table>
				</div>
			</td>
			</tr>
			</table>
		</div>
		</form>
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
